//
//  HeadersH2TinyButtonModel.swift
//  MVMCoreUI
//
//  Created by Lekshmi S on 11/03/20.
//  Copyright © 2020 Verizon Wireless. All rights reserved.
//

import Foundation


public class HeadersH2TinyButtonModel: HeaderModel, MoleculeModelProtocol, ParentMoleculeModelProtocol {
    //--------------------------------------------------
    // MARK: - Properties
    //--------------------------------------------------
    
    public static var identifier: String = "headerH2BtnTny"
    public var titleLockup: TitleLockupModel
    public var button: ButtonModel
    private var helper = DeprecatedHeadlineBodyHelper()
    
    public var children: [MoleculeModelProtocol] {
        [titleLockup, button]
    }
    
    public func replaceChildMolecule(with molecule: MoleculeModelProtocol) throws -> Bool  {
        return try replaceChildMolecule(at: &titleLockup, with: molecule)
        || replaceChildMolecule(at: &button, with: molecule)
    }
    
    //--------------------------------------------------
    // MARK: - Initializer
    //--------------------------------------------------
    
    public init(titleLockup: TitleLockupModel, button: ButtonModel) {
        self.titleLockup = titleLockup
        self.button = button
        super.init()
    }
    
    //--------------------------------------------------
    // MARK: - Methods
    //--------------------------------------------------
    
    public override func setDefaults() {
        if topPadding == nil {
            topPadding = Padding.Component.VerticalMarginSpacing
        }
        if bottomPadding == nil {
            bottomPadding = Padding.Component.VerticalMarginSpacing
        }
        if titleLockup.title.fontStyle == nil {
            titleLockup.title.fontStyle = Styler.Font.RegularTitleXLarge
        }
        if titleLockup.subTitle?.fontStyle == nil {
            titleLockup.subTitle?.fontStyle = Styler.Font.RegularTitleMedium
        }
        super.setDefaults()
        button.style = .secondary
        button.size = .small
    }
    
    //--------------------------------------------------
    // MARK: - Keys
    //--------------------------------------------------
    
    private enum CodingKeys: String, CodingKey {
        case moleculeName
        case titleLockup
        case button
    }
    
    //--------------------------------------------------
    // MARK: - Codec
    //--------------------------------------------------
    
    required public init(from decoder: Decoder) throws {
        let typeContainer = try decoder.container(keyedBy: CodingKeys.self)
        titleLockup = try helper.deprecatedCreate(from: decoder) ?? typeContainer.decodeMolecule(codingKey: .titleLockup)
        button = try typeContainer.decode(ButtonModel.self, forKey: .button)
        try super.init(from: decoder)
    }
    
    public override func encode(to encoder: Encoder) throws {
        try super.encode(to: encoder)
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encode(moleculeName, forKey: .moleculeName)
        try container.encode(button, forKey: .button)
        guard try !helper.deprecatedEncode(to: encoder) else { return }
        try container.encode(titleLockup, forKey: .titleLockup)
    }
}
